# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

Public Member Functions | Protected Member Functions | Protected Attributes | Friends

# vl::FBOAbstractAttachment Class Reference

Abstract class that represents a framebuffer object attachment to be used with FBORenderTarget. More...

`#include <FramebufferObject.hpp>`

Inheritance diagram for vl::FBOAbstractAttachment:

List of all members.

## Public Member Functions

virtual const char * | className ()
| Returns the name of the class.
| FBOAbstractAttachment ()
| Constructor.
virtual | ~FBOAbstractAttachment ()
| Destructor, removes automatically the FBO attachment from all bound FBO render targets and releases any OpenGL resource.
virtual void | destroy ()
| Removes the FBO attachment from all bound FBO render targets and releases any associated OpenGL resource.
const std::set< ref < FBORenderTarget > > & | fboRenderTargets () const
| Returns an std::set containing the FBORenderTarget that use this FBO attachment.

## Protected Member Functions

virtual void | bindAttachment (FBORenderTarget *fbo, EAttachmentPoint attach_point)=0

## Protected Attributes

std::set< ref< FBORenderTarget > > | mFBORenderTargets

## Friends

class | FBORenderTarget

## Detailed Description

Abstract class that represents a framebuffer object attachment to be used with FBORenderTarget.

Definition at line 49 of file FramebufferObject.hpp.

## Constructor & Destructor Documentation

vl::FBOAbstractAttachment::FBOAbstractAttachment | ( | ) | `[inline]`

Constructor.

Definition at line 62 of file FramebufferObject.hpp.

virtual vl::FBOAbstractAttachment::~FBOAbstractAttachment | ( | ) | `[inline, virtual]`

Destructor, removes automatically the FBO attachment from all bound FBO render targets and releases any OpenGL resource.

Definition at line 65 of file FramebufferObject.hpp.

## Member Function Documentation

virtual const char* vl::FBOAbstractAttachment::className | ( | ) | `[inline, virtual]`

Returns the name of the class.

Reimplemented from vl::Object.

Reimplemented in vl::FBORenderbufferAttachment, vl::FBOColorBufferAttachment, vl::FBODepthBufferAttachment, vl::FBOStencilBufferAttachment, vl::FBODepthStencilBufferAttachment, vl::FBOAbstractTextureAttachment, vl::FBOTexture1DAttachment, vl::FBOTexture2DAttachment, vl::FBOTextureAttachment, vl::FBOTexture3DAttachment, and vl::FBOTextureLayerAttachment.

Definition at line 59 of file FramebufferObject.hpp.

void FBOAbstractAttachment::destroy | ( | ) | `[virtual]`

Removes the FBO attachment from all bound FBO render targets and releases any associated OpenGL resource.

Reimplemented in vl::FBORenderbufferAttachment.

Definition at line 491 of file FramebufferObject.cpp.

References fboRenderTargets().

const std::set< ref<FBORenderTarget> >& vl::FBOAbstractAttachment::fboRenderTargets | ( | ) | const`[inline]`

Returns an std::set containing the FBORenderTarget that use this FBO attachment.

Definition at line 71 of file FramebufferObject.hpp.

Referenced by destroy().

virtual void vl::FBOAbstractAttachment::bindAttachment | ( | FBORenderTarget * | fbo,
|  | EAttachmentPoint | attach_point
| ) |  | `[protected, pure virtual]`

Implemented in vl::FBORenderbufferAttachment, vl::FBOTexture1DAttachment, vl::FBOTexture2DAttachment, vl::FBOTextureAttachment, vl::FBOTexture3DAttachment, and vl::FBOTextureLayerAttachment.

Referenced by vl::FBORenderTarget::addDepthAttachment(), vl::FBORenderTarget::addDepthStencilAttachment(), vl::FBORenderTarget::addStencilAttachment(), and vl::FBORenderTarget::addTextureAttachment().

## Friends And Related Function Documentation

friend class FBORenderTarget`[friend]`

Reimplemented in vl::FBORenderbufferAttachment.

Definition at line 51 of file FramebufferObject.hpp.

## Member Data Documentation

std::set< ref<FBORenderTarget> > vl::FBOAbstractAttachment::mFBORenderTargets`[protected]`

Definition at line 77 of file FramebufferObject.hpp.

Referenced by vl::FBORenderTarget::addColorAttachment(), vl::FBORenderTarget::addDepthAttachment(), vl::FBORenderTarget::addDepthStencilAttachment(), vl::FBORenderTarget::addStencilAttachment(), vl::FBORenderTarget::addTextureAttachment(), and vl::FBORenderTarget::removeAttachment().

The documentation for this class was generated from the following files:

- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/FramebufferObject.hpp
- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/FramebufferObject.cpp

Visualization Library v2011.05.1142 Reference Documentation
Copyright 2005-2011 Michele Bosi. All rights reserved.
Updated on Thu May 26 2011 22:51:40.
Permission is granted to use this page to write and publish articles regarding Visualization Library.